Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 166)
@@ -683,5 +683,9 @@
 UInt TEncSearch::xPatternRefinement( TComPattern* pcPatternKey,
                                     TComMv baseRefMv,
-                                    Int iFrac, TComMv& rcMvFrac )
+                                    Int iFrac, TComMv& rcMvFrac
+#if VSP_MV_ZERO
+                                   ,Bool bIsVsp
+#endif
+                                   )
 {
   UInt  uiDist;
@@ -699,5 +703,10 @@
   TComMv* pcMvRefine = (iFrac == 2 ? s_acMvRefineH : s_acMvRefineQ);
   
+#if VSP_MV_ZERO
+  UInt iAround = ( bIsVsp )? 1:9;
+  for (UInt i = 0; i < iAround; i++)
+#else
   for (UInt i = 0; i < 9; i++)
+#endif
   {
     TComMv cMvTest = pcMvRefine[i];
@@ -871,4 +880,11 @@
       {
         m_pcEntropyCoder->encodeSkipFlag( pcCU, 0, true );
+#if FORCE_REF_VSP==1
+        if( pcCU->getSlice()->getViewId() != 0 )
+#if VSP_TEXT_ONLY
+        if( !pcCU->getSlice()->getSPS()->isDepth() )
+#endif
+          m_pcEntropyCoder->encodeVspFlag ( pcCU, 0, true );
+#endif
         m_pcEntropyCoder->encodePredMode( pcCU, 0, true );
       }
@@ -2751,7 +2767,15 @@
 #if AMP_MRG
 #if LG_RESTRICTEDRESPRED_M24766
-Void TEncSearch::predInterSearch( TComDataCU* pcCU, TComYuv* pcOrgYuv, TComYuv* rpcResiPredYuv, TComYuv*& rpcPredYuv, TComYuv*& rpcResiYuv, TComYuv*& rpcRecoYuv, Bool bUseRes, Bool bUseMRG )
-#else
-Void TEncSearch::predInterSearch( TComDataCU* pcCU, TComYuv* pcOrgYuv, TComYuv*& rpcPredYuv, TComYuv*& rpcResiYuv, TComYuv*& rpcRecoYuv, Bool bUseRes, Bool bUseMRG )
+Void TEncSearch::predInterSearch( TComDataCU* pcCU, TComYuv* pcOrgYuv, TComYuv* rpcResiPredYuv, TComYuv*& rpcPredYuv, TComYuv*& rpcResiYuv, TComYuv*& rpcRecoYuv, Bool bUseRes, Bool bUseMRG 
+#if FORCE_REF_VSP==1
+                                 , Bool bForceRefVsp
+#endif
+                                 )
+#else
+Void TEncSearch::predInterSearch( TComDataCU* pcCU, TComYuv* pcOrgYuv, TComYuv*& rpcPredYuv, TComYuv*& rpcResiYuv, TComYuv*& rpcRecoYuv, Bool bUseRes, Bool bUseMRG
+#if FORCE_REF_VSP==1
+                                 , Bool bForceRefVsp
+#endif
+                                 )
 #endif
 #else
@@ -2813,4 +2837,30 @@
 #endif
 
+#if FORCE_REF_VSP==1
+  if( bForceRefVsp )
+  {
+    assert( ePartSize == SIZE_2Nx2N );
+
+    //  Clear Motion Field
+    pcCU->getCUMvField(REF_PIC_LIST_0)->setAllMvField( TComMvField(), ePartSize, 0, pcCU->getDepth(0), 0 );
+    pcCU->getCUMvField(REF_PIC_LIST_1)->setAllMvField( TComMvField(), ePartSize, 0, pcCU->getDepth(0), 0 );
+    pcCU->getCUMvField(REF_PIC_LIST_0)->setAllMvd    ( cMvZero,       ePartSize, 0, pcCU->getDepth(0), 0 );
+    pcCU->getCUMvField(REF_PIC_LIST_1)->setAllMvd    ( cMvZero,       ePartSize, 0, pcCU->getDepth(0), 0 );
+
+    //pcCU->getCUMvField(REF_PIC_LIST_0)->setAllRefIdx ( pcCU->getSlice()->getRefIdxVsp(REF_PIC_LIST_0), ePartSize, 0, pcCU->getDepth(0), 0 );
+    //pcCU->getCUMvField(REF_PIC_LIST_1)->setAllRefIdx ( pcCU->getSlice()->getRefIdxVsp(REF_PIC_LIST_1), ePartSize, 0, pcCU->getDepth(0), 0 );
+
+    pcCU->setMVPIdxSubParts( -1, REF_PIC_LIST_0, 0, 0, pcCU->getDepth(0));
+    pcCU->setMVPNumSubParts( -1, REF_PIC_LIST_0, 0, 0, pcCU->getDepth(0));
+    pcCU->setMVPIdxSubParts( -1, REF_PIC_LIST_1, 0, 0, pcCU->getDepth(0));
+    pcCU->setMVPNumSubParts( -1, REF_PIC_LIST_1, 0, 0, pcCU->getDepth(0));
+
+    rpcPredYuv->copyFromPicYuv( pcCU->getPic()->getPicYuvSynth(), pcCU->getAddr(), pcCU->getZorderIdxInCU() );
+    setWpScalingDistParam( pcCU, -1, REF_PIC_LIST_X );
+
+    return;
+  }
+#endif
+
 #if ZERO_MVD_EST
   Int           aiZeroMvdMvpIdx[2] = {-1, -1};
@@ -2833,4 +2883,27 @@
 #if HHI_INTER_VIEW_MOTION_PRED
   Int iNumAMVPCands = AMVP_MAX_NUM_CANDS + ( pcCU->getSlice()->getSPS()->getMultiviewMvPredMode() ? 1 : 0 );
+#endif
+
+#if VSP_MV_ZERO
+  bool bIsVsp = false;
+  //Bool bWholeCUCanBeSynthesized = false;
+  //Bool bSubCUCanBeSynthesized[4];
+  //if( pcCU->getSlice()->getViewId() )
+  //{
+  //  Bool * pbSubCUCanBeSynthesized = bSubCUCanBeSynthesized;
+  //  pcCU->getPic()->checkSynthesisAvailability(/*rpcBestCU, */pcCU->getAddr(), pcCU->getZorderIdxInCU(), pcCU->getDepth(0), pbSubCUCanBeSynthesized); //KUBA SYNTH
+  //  Int  iSubCUCanBeSynthesizedCnt = 0;
+  //  for(Int i = 0; i < 4; i++)
+  //  {
+  //    if (bSubCUCanBeSynthesized[i])
+  //    {
+  //      iSubCUCanBeSynthesizedCnt ++;
+  //    }
+  //  }
+  //  if(iSubCUCanBeSynthesizedCnt == 4)
+  //  {
+  //    bWholeCUCanBeSynthesized = true;
+  //  }
+  //}
 #endif
 
@@ -2857,4 +2930,5 @@
     for (Int iNumRef=0; iNumRef < MAX_NUM_REF; iNumRef++) uiCostTempL0[iNumRef] = MAX_UINT;
     UInt          uiBitsTempL0[MAX_NUM_REF];
+
 #if LG_RESTRICTEDRESPRED_M24766
     Int iPUResiPredShift[4] = {0, 0, 0, 0};
@@ -2885,4 +2959,11 @@
       for ( Int iRefIdxTemp = 0; iRefIdxTemp < pcCU->getSlice()->getNumRefIdx(eRefPicList); iRefIdxTemp++ )
       {
+#if VSP_MV_ZERO
+        bIsVsp = (pcCU->getSlice()->getViewId() && pcCU->getSlice()->getRefViewId(eRefPicList, iRefIdxTemp) == NUM_VIEW_VSP);
+        //if( bIsVsp && !bWholeCUCanBeSynthesized )
+        //{
+        //  continue;
+        //}
+#endif
 #if LG_RESTRICTEDRESPRED_M24766
         if( pcCU->getResPredFlag( 0 ))
@@ -2908,4 +2989,14 @@
           if ( iRefIdxTemp == pcCU->getSlice()->getNumRefIdx(eRefPicList)-1 ) uiBitsTemp--;
         }
+#if VSP_MV_ZERO
+        if( bIsVsp )
+        {
+          aaiMvpIdx[iRefList][iRefIdxTemp] = -1;
+          aaiMvpNum[iRefList][iRefIdxTemp] = -1;
+          cMvPred[iRefList][iRefIdxTemp].setZero();
+        }
+        else
+        {
+#endif
 #if H0111_MVD_L1_ZERO
 #if ZERO_MVD_EST
@@ -2937,4 +3028,7 @@
 #else
         uiBitsTemp += m_auiMVPIdxCost[aaiMvpIdx[iRefList][iRefIdxTemp]][AMVP_MAX_NUM_CANDS];
+#endif
+#if VSP_MV_ZERO
+        } // if( bIsVsp )
 #endif
 #if ZERO_MVD_EST
@@ -2973,8 +3067,20 @@
               else
               {
+#if VSP_MV_ZERO
+                if( pcCU->getSlice()->getViewId() && pcCU->getSlice()->getRefViewId(eRefPicList, iRefIdxTemp) == NUM_VIEW_VSP )
+                {
+                  cMvTemp[1][iRefIdxTemp].setZero();
+                  uiCostTemp = 0;
+                }
+                else
+                {
+#endif
                 cMvTemp[1][iRefIdxTemp] = cMvTemp[0][pcCU->getSlice()->getRefIdxOfL0FromRefIdxOfL1(iRefIdxTemp)]; 
                 uiCostTemp = uiCostTempL0[pcCU->getSlice()->getRefIdxOfL0FromRefIdxOfL1(iRefIdxTemp)];
                 /*first subtract the bit-rate part of the cost of the other list*/
                 uiCostTemp -= m_pcRdCost->getCost( uiBitsTempL0[pcCU->getSlice()->getRefIdxOfL0FromRefIdxOfL1(iRefIdxTemp)] );
+#if VSP_MV_ZERO
+                }
+#endif
               }
               /*correct the bit-rate part of the current ref*/
@@ -2986,5 +3092,9 @@
             else
             {
+#if VSP_MV_ZERO
+              xMotionEstimation ( pcCU, pcOrgYuv, iPartIdx, eRefPicList, &cMvPred[iRefList][iRefIdxTemp], iRefIdxTemp, cMvTemp[iRefList][iRefIdxTemp], bIsVsp, uiBitsTemp, uiCostTemp );
+#else
               xMotionEstimation ( pcCU, pcOrgYuv, iPartIdx, eRefPicList, &cMvPred[iRefList][iRefIdxTemp], iRefIdxTemp, cMvTemp[iRefList][iRefIdxTemp], uiBitsTemp, uiCostTemp );
+#endif
             }
         }
@@ -2998,9 +3108,21 @@
           else
           { 
+#if VSP_MV_ZERO
+            xMotionEstimation ( pcCU, pcOrgYuv, iPartIdx, eRefPicList, &cMvPred[iRefList][iRefIdxTemp], iRefIdxTemp, cMvTemp[iRefList][iRefIdxTemp], bIsVsp, uiBitsTemp, uiCostTemp );
+#else
             xMotionEstimation ( pcCU, pcOrgYuv, iPartIdx, eRefPicList, &cMvPred[iRefList][iRefIdxTemp], iRefIdxTemp, cMvTemp[iRefList][iRefIdxTemp], uiBitsTemp, uiCostTemp );
+#endif
           }        
         }
 #else
         xMotionEstimation ( pcCU, pcOrgYuv, iPartIdx, eRefPicList, &cMvPred[iRefList][iRefIdxTemp], iRefIdxTemp, cMvTemp[iRefList][iRefIdxTemp], uiBitsTemp, uiCostTemp );
+#endif
+#if VSP_MV_ZERO
+        if( bIsVsp )
+        {
+          cMvPred[iRefList][iRefIdxTemp].setZero();
+        }
+        else
+        {
 #endif
         xCopyAMVPInfo(pcCU->getCUMvField(eRefPicList)->getAMVPInfo(), &aacAMVPInfo[iRefList][iRefIdxTemp]); // must always be done ( also when AMVP_MODE = AM_NONE )
@@ -3009,4 +3131,7 @@
           xCheckBestMVP(pcCU, eRefPicList, cMvTemp[iRefList][iRefIdxTemp], cMvPred[iRefList][iRefIdxTemp], aaiMvpIdx[iRefList][iRefIdxTemp], uiBitsTemp, uiCostTemp);
         }
+#if VSP_MV_ZERO
+        }
+#endif
 
         if(pcCU->getSlice()->getNumRefIdx(REF_PIC_LIST_C) > 0 && !pcCU->getSlice()->getNoBackPredFlag())
@@ -3088,8 +3213,21 @@
       if(pcCU->getSlice()->getMvdL1ZeroFlag())
       {
+#if VSP_MV_ZERO
+        bIsVsp = (pcCU->getSlice()->getViewId() && pcCU->getSlice()->getRefViewId(REF_PIC_LIST_1, bestBiPRefIdxL1) == NUM_VIEW_VSP);
+
+        if( bIsVsp )
+        {
+          cMvPredBi[1][bestBiPRefIdxL1].setZero();
+        }
+        else
+        {
+#endif
         xCopyAMVPInfo(&aacAMVPInfo[1][bestBiPRefIdxL1], pcCU->getCUMvField(REF_PIC_LIST_1)->getAMVPInfo());
         pcCU->setMVPIdxSubParts( bestBiPMvpL1, REF_PIC_LIST_1, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
         aaiMvpIdxBi[1][bestBiPRefIdxL1] = bestBiPMvpL1;
         cMvPredBi[1][bestBiPRefIdxL1]   = pcCU->getCUMvField(REF_PIC_LIST_1)->getAMVPInfo()->m_acMvCand[bestBiPMvpL1];
+#if VSP_MV_ZERO
+        }
+#endif
 
         cMvBi[1] = cMvPredBi[1][bestBiPRefIdxL1];
@@ -3109,8 +3247,15 @@
         }
 
+#if VSP_MV_ZERO
+        if( !bIsVsp )
+        {
+#endif
 #if HHI_INTER_VIEW_MOTION_PRED
         uiMotBits[1] += m_auiMVPIdxCost[aaiMvpIdxBi[1][bestBiPRefIdxL1]][iNumAMVPCands];
 #else
         uiMotBits[1] += m_auiMVPIdxCost[aaiMvpIdxBi[1][bestBiPRefIdxL1]][AMVP_MAX_NUM_CANDS];
+#endif
+#if VSP_MV_ZERO
+        }
 #endif
 
@@ -3168,4 +3313,11 @@
         for ( Int iRefIdxTemp = iRefStart; iRefIdxTemp <= iRefEnd; iRefIdxTemp++ )
         {
+#if VSP_MV_ZERO
+          bIsVsp = (pcCU->getSlice()->getViewId() && pcCU->getSlice()->getRefViewId(eRefPicList, iRefIdxTemp) == NUM_VIEW_VSP);
+          //if( bIsVsp && !bWholeCUCanBeSynthesized )
+          //{
+          //  continue;
+          //}
+#endif
           uiBitsTemp = uiMbBits[2] + uiMotBits[1-iRefList];
           if ( pcCU->getSlice()->getNumRefIdx(eRefPicList) > 1 )
@@ -3174,8 +3326,15 @@
             if ( iRefIdxTemp == pcCU->getSlice()->getNumRefIdx(eRefPicList)-1 ) uiBitsTemp--;
           }
+#if VSP_MV_ZERO
+          if( !bIsVsp )
+          {
+#endif
 #if HHI_INTER_VIEW_MOTION_PRED
           uiBitsTemp += m_auiMVPIdxCost[aaiMvpIdxBi[iRefList][iRefIdxTemp]][iNumAMVPCands];
 #else
           uiBitsTemp += m_auiMVPIdxCost[aaiMvpIdxBi[iRefList][iRefIdxTemp]][AMVP_MAX_NUM_CANDS];
+#endif
+#if VSP_MV_ZERO
+          }
 #endif
 #if LG_RESTRICTEDRESPRED_M24766
@@ -3211,5 +3370,13 @@
 #endif
           // call ME
+#if VSP_MV_ZERO
+          xMotionEstimation ( pcCU, pcOrgYuv, iPartIdx, eRefPicList, &cMvPredBi[iRefList][iRefIdxTemp], iRefIdxTemp, cMvTemp[iRefList][iRefIdxTemp], bIsVsp, uiBitsTemp, uiCostTemp, true );
+#else
           xMotionEstimation ( pcCU, pcOrgYuv, iPartIdx, eRefPicList, &cMvPredBi[iRefList][iRefIdxTemp], iRefIdxTemp, cMvTemp[iRefList][iRefIdxTemp], uiBitsTemp, uiCostTemp, true );
+#endif
+#if VSP_MV_ZERO
+          if( !bIsVsp )
+          {
+#endif
           if ( pcCU->getAMVPMode(uiPartAddr) == AM_EXPL )
           {
@@ -3217,5 +3384,8 @@
             xCheckBestMVP(pcCU, eRefPicList, cMvTemp[iRefList][iRefIdxTemp], cMvPredBi[iRefList][iRefIdxTemp], aaiMvpIdxBi[iRefList][iRefIdxTemp], uiBitsTemp, uiCostTemp);
           }
-          
+#if VSP_MV_ZERO
+          }
+#endif
+
           if ( uiCostTemp < uiCostBi )
           {
@@ -3249,12 +3419,30 @@
           if ( uiCostBi <= uiCost[0] && uiCostBi <= uiCost[1] && pcCU->getAMVPMode(uiPartAddr) == AM_EXPL )
           {
+#if VSP_MV_ZERO
+            bIsVsp = (pcCU->getSlice()->getViewId() && pcCU->getSlice()->getRefViewId(REF_PIC_LIST_0, iRefIdxBi[0]) == NUM_VIEW_VSP);
+
+            if( !bIsVsp )
+            {
+#endif
             xCopyAMVPInfo(&aacAMVPInfo[0][iRefIdxBi[0]], pcCU->getCUMvField(REF_PIC_LIST_0)->getAMVPInfo());
             xCheckBestMVP(pcCU, REF_PIC_LIST_0, cMvBi[0], cMvPredBi[0][iRefIdxBi[0]], aaiMvpIdxBi[0][iRefIdxBi[0]], uiBits[2], uiCostBi);
+#if VSP_MV_ZERO
+            }
+#endif
 #if H0111_MVD_L1_ZERO
             if(!pcCU->getSlice()->getMvdL1ZeroFlag())
             {
 #endif
+#if VSP_MV_ZERO
+              bIsVsp = (pcCU->getSlice()->getViewId() && pcCU->getSlice()->getRefViewId(REF_PIC_LIST_1, iRefIdxBi[1]) == NUM_VIEW_VSP);
+
+              if( !bIsVsp )
+              {
+#endif
               xCopyAMVPInfo(&aacAMVPInfo[1][iRefIdxBi[1]], pcCU->getCUMvField(REF_PIC_LIST_1)->getAMVPInfo());
               xCheckBestMVP(pcCU, REF_PIC_LIST_1, cMvBi[1], cMvPredBi[1][iRefIdxBi[1]], aaiMvpIdxBi[1][iRefIdxBi[1]], uiBits[2], uiCostBi);
+#if VSP_MV_ZERO
+              }
+#endif
 #if H0111_MVD_L1_ZERO
             }
@@ -3417,8 +3605,22 @@
       pcCU->setInterDirSubParts( 3, uiPartAddr, iPartIdx, pcCU->getDepth(0) );
       
+#if VSP_MV_ZERO
+      bIsVsp = (pcCU->getSlice()->getViewId() && pcCU->getSlice()->getRefViewId(REF_PIC_LIST_0, iRefIdxBi[0]) == NUM_VIEW_VSP);
+      if( !bIsVsp )
+      {
+#endif
       pcCU->setMVPIdxSubParts( aaiMvpIdxBi[0][iRefIdxBi[0]], REF_PIC_LIST_0, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
       pcCU->setMVPNumSubParts( aaiMvpNum[0][iRefIdxBi[0]], REF_PIC_LIST_0, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
+#if VSP_MV_ZERO
+      }
+      bIsVsp = (pcCU->getSlice()->getViewId() && pcCU->getSlice()->getRefViewId(REF_PIC_LIST_1, iRefIdxBi[1]) == NUM_VIEW_VSP);
+      if( !bIsVsp )
+      {
+#endif
       pcCU->setMVPIdxSubParts( aaiMvpIdxBi[1][iRefIdxBi[1]], REF_PIC_LIST_1, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
       pcCU->setMVPNumSubParts( aaiMvpNum[1][iRefIdxBi[1]], REF_PIC_LIST_1, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
+#if VSP_MV_ZERO
+      }
+#endif
 
       uiMEBits = uiBits[2];
@@ -3435,6 +3637,14 @@
       pcCU->setInterDirSubParts( 1, uiPartAddr, iPartIdx, pcCU->getDepth(0) );
       
+#if VSP_MV_ZERO
+      bIsVsp = (pcCU->getSlice()->getViewId() && pcCU->getSlice()->getRefViewId(REF_PIC_LIST_0, iRefIdx[0]) == NUM_VIEW_VSP);
+      if( !bIsVsp )
+      {
+#endif
       pcCU->setMVPIdxSubParts( aaiMvpIdx[0][iRefIdx[0]], REF_PIC_LIST_0, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
       pcCU->setMVPNumSubParts( aaiMvpNum[0][iRefIdx[0]], REF_PIC_LIST_0, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
+#if VSP_MV_ZERO
+      }
+#endif
 
       uiMEBits = uiBits[0];
@@ -3451,6 +3661,14 @@
       pcCU->setInterDirSubParts( 2, uiPartAddr, iPartIdx, pcCU->getDepth(0) );
       
+#if VSP_MV_ZERO
+      bIsVsp = (pcCU->getSlice()->getViewId() && pcCU->getSlice()->getRefViewId(REF_PIC_LIST_1, iRefIdx[1]) == NUM_VIEW_VSP);
+      if( !bIsVsp )
+      {
+#endif
       pcCU->setMVPIdxSubParts( aaiMvpIdx[1][iRefIdx[1]], REF_PIC_LIST_1, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
       pcCU->setMVPNumSubParts( aaiMvpNum[1][iRefIdx[1]], REF_PIC_LIST_1, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
+#if VSP_MV_ZERO
+      }
+#endif
 
       uiMEBits = uiBits[1];
@@ -3888,5 +4106,9 @@
 }
 
+#if VSP_MV_ZERO
+Void TEncSearch::xMotionEstimation( TComDataCU* pcCU, TComYuv* pcYuvOrg, Int iPartIdx, RefPicList eRefPicList, TComMv* pcMvPred, Int iRefIdxPred, TComMv& rcMv, Bool bIsVsp, UInt& ruiBits, UInt& ruiCost, Bool bBi  )
+#else
 Void TEncSearch::xMotionEstimation( TComDataCU* pcCU, TComYuv* pcYuvOrg, Int iPartIdx, RefPicList eRefPicList, TComMv* pcMvPred, Int iRefIdxPred, TComMv& rcMv, UInt& ruiBits, UInt& ruiCost, Bool bBi  )
+#endif
 {
   UInt          uiPartAddr;
@@ -3901,5 +4123,9 @@
   m_iSearchRange = m_aaiAdaptSR[eRefPicList][iRefIdxPred];
   
+#if VSP_MV_ZERO
+  Int           iSrchRng      = ( bIsVsp ? 0 : ( bBi ? m_bipredSearchRange : m_iSearchRange ) );
+#else
   Int           iSrchRng      = ( bBi ? m_bipredSearchRange : m_iSearchRange );
+#endif
   TComPattern*  pcPatternKey  = pcCU->getPattern        ();
   
@@ -3947,4 +4173,7 @@
   m_pcRdCost->setCostScale  ( 2 );
 
+#if VSP_MV_ZERO
+  if( !bIsVsp )
+#endif
 #if HHI_INTER_VIEW_MOTION_PRED
   { // init inter-view regularization
@@ -3965,8 +4194,17 @@
   }
 #endif
+#if VSP_MV_ZERO
+  else { // bIsVsp
+    m_pcRdCost->setMultiviewReg( 0 );
+  }
+#endif
 
   setWpScalingDistParam( pcCU, iRefIdxPred, eRefPicList );
   //  Do integer search
+#if VSP_MV_ZERO
+  if ( !m_iFastSearch || bBi || bIsVsp )
+#else
   if ( !m_iFastSearch || bBi )
+#endif
   {
     xPatternSearch      ( pcPatternKey, piRefY, iRefStride, &cMvSrchRngLT, &cMvSrchRngRB, rcMv, ruiCost );
@@ -3979,4 +4217,5 @@
   
   m_pcRdCost->getMotionCost( 1, 0 );
+
 #if HHI_FULL_PEL_DEPTH_MAP_MV_ACC
   if( ! pcCU->getSlice()->getIsDepth() )
@@ -3988,4 +4227,7 @@
     xPatternSearchFracDIF( pcCU, pcPatternKey, piRefY, iRefStride, &rcMv, cMvHalf, cMvQter, ruiCost
                           ,bBi
+#if VSP_MV_ZERO
+                          ,bIsVsp
+#endif
                           );
   }
@@ -4006,5 +4248,12 @@
     ruiCost += m_pcRdCost->getCost( uiMvBits );
 #endif
-  
+
+#if VSP_MV_ZERO
+  if( bIsVsp ) {
+    uiMvBits = 0; // vector zero & not output
+    assert( rcMv.getHor()==0 && rcMv.getVer()==0 );
+  }
+#endif
+
   ruiBits      += uiMvBits;
   ruiCost       = (UInt)( floor( fWeight * ( (Double)ruiCost - (Double)m_pcRdCost->getCost( uiMvBits ) ) ) + (Double)m_pcRdCost->getCost( ruiBits ) );
@@ -4304,4 +4553,7 @@
                                        UInt& ruiCost
                                        ,Bool biPred
+#if VSP_MV_ZERO
+                                       ,Bool bIsVsp
+#endif
                                        )
 {
@@ -4322,5 +4574,9 @@
   rcMvHalf = *pcMvInt;   rcMvHalf <<= 1;    // for mv-cost
   TComMv baseRefMv(0, 0);
-  ruiCost = xPatternRefinement( pcPatternKey, baseRefMv, 2, rcMvHalf   );
+  ruiCost = xPatternRefinement( pcPatternKey, baseRefMv, 2, rcMvHalf
+#if VSP_MV_ZERO
+                                   ,bIsVsp
+#endif
+    );
   
   m_pcRdCost->setCostScale( 0 );
@@ -4332,5 +4588,9 @@
   rcMvQter = *pcMvInt;   rcMvQter <<= 1;    // for mv-cost
   rcMvQter += rcMvHalf;  rcMvQter <<= 1;
-  ruiCost = xPatternRefinement( pcPatternKey, baseRefMv, 1, rcMvQter );
+  ruiCost = xPatternRefinement( pcPatternKey, baseRefMv, 1, rcMvQter
+#if VSP_MV_ZERO
+                                   ,bIsVsp
+#endif
+    );
 }
 
@@ -4367,5 +4627,9 @@
 #endif
   //  No residual coding : SKIP mode
-  if ( ePredMode == MODE_SKIP && bSkipRes )
+  if ( (ePredMode == MODE_SKIP && bSkipRes) 
+#if FORCE_REF_VSP==1
+    || ePredMode == MODE_SYNTH
+#endif
+    )
   {
     rpcYuvResi->clear();
@@ -5737,4 +6001,11 @@
     m_pcEntropyCoder->resetBits();
     m_pcEntropyCoder->encodeSkipFlag(pcCU, 0, true);
+#if FORCE_REF_VSP==1
+    if( pcCU->getSlice()->getViewId() != 0 )
+#if VSP_TEXT_ONLY
+    if( !pcCU->getSlice()->getSPS()->isDepth() )
+#endif
+      m_pcEntropyCoder->encodeVspFlag ( pcCU, 0, true );
+#endif
     m_pcEntropyCoder->encodeMergeIndex(pcCU, 0, 0, true);
 #if HHI_INTER_VIEW_RESIDUAL_PRED
@@ -5743,4 +6014,13 @@
     ruiBits += m_pcEntropyCoder->getNumberOfWrittenBits();
   }
+#if FORCE_REF_VSP==1
+  else if( pcCU->isVspMode( 0 ) )
+  {
+    m_pcEntropyCoder->resetBits();
+    m_pcEntropyCoder->encodeSkipFlag( pcCU, 0, true );
+    m_pcEntropyCoder->encodeVspFlag ( pcCU, 0, true );
+    ruiBits += m_pcEntropyCoder->getNumberOfWrittenBits();
+  }
+#endif
   else
   {
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSearch.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSearch.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSearch.h	(revision 166)
@@ -144,5 +144,9 @@
   UInt  xPatternRefinement( TComPattern* pcPatternKey,
                            TComMv baseRefMv,
-                           Int iFrac, TComMv& rcMvFrac );
+                           Int iFrac, TComMv& rcMvFrac
+#if VSP_MV_ZERO
+                          ,Bool bIsVsp
+#endif
+                          );
   
   typedef struct
@@ -197,4 +201,7 @@
 #if AMP_MRG
                                  ,Bool        bUseMRG = false
+#endif
+#if FORCE_REF_VSP==1
+                                 ,Bool        bForceRefVsp = false
 #endif
                                 );
@@ -486,4 +493,7 @@
                                     Int           iRefIdxPred,
                                     TComMv&       rcMv,
+#if VSP_MV_ZERO
+                                    Bool          bIsVsp,
+#endif
                                     UInt&         ruiBits,
                                     UInt&         ruiCost,
@@ -531,4 +541,7 @@
                                     UInt&         ruiCost 
                                    ,Bool biPred
+#if VSP_MV_ZERO
+                                   ,Bool bIsVsp
+#endif
                                    );
   
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncTop.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncTop.cpp	(revision 166)
@@ -79,4 +79,14 @@
   m_pcBitCounters          = NULL;
   m_pcRdCosts              = NULL;
+
+#if VSP_N
+  m_pcPicVSP = NULL;
+  m_pcPicAvail = NULL;
+#endif
+
+#if VSP_SLICE_HEADER
+  m_bUseVSP = false;
+#endif
+
 }
 
@@ -184,4 +194,18 @@
   }
 #endif
+
+#if VSP_N
+  m_pcPicVSP = new TComPic;
+  m_pcPicVSP->create( getSourceWidth(), getSourceHeight(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth );
+  //m_pcPicVSP->getCurrSlice()->setViewId( this->getViewId() );
+  m_pcPicVSP->getCurrSlice()->setViewId( NUM_VIEW_VSP );
+  m_pcPicVSP->getCurrSlice()->setViewOrderIdx( m_iViewOrderIdx );
+
+  m_pcPicAvail = new TComPic;
+  m_pcPicAvail->create( getSourceWidth(), getSourceHeight(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth );
+  m_pcPicAvail->getCurrSlice()->setViewId( 99 );
+  m_pcPicAvail->getCurrSlice()->setViewOrderIdx( m_iViewOrderIdx );
+#endif
+
 }
 
@@ -325,4 +349,19 @@
   }
   
+#if VSP_N
+  if( m_pcPicVSP )
+  {
+    m_pcPicVSP->destroy();
+    delete m_pcPicVSP;
+    m_pcPicVSP = NULL;
+  }
+  if( m_pcPicAvail )
+  {
+    m_pcPicAvail->destroy();
+    delete m_pcPicAvail;
+    m_pcPicAvail = NULL;
+  }
+#endif
+
   return;
 }
@@ -391,4 +430,51 @@
 
   m_iMaxRefPicNum = 0;
+
+#if VSP_N
+  m_pcPicVSP->setCurrSliceIdx( 0 );
+  m_pcPicVSP->getCurrSlice()->setSPS( this->getSPS() );
+  m_pcPicVSP->getCurrSlice()->setPPS( this->getPPS() );
+  m_pcPicVSP->getCurrSlice()->setPPSId( this->getPPS()->getPPSId() );
+  //initialize the motion vector field with zeros - How about the RefIdx ????
+  //IS THIS REALLY NECESSARY ????
+  for ( int i=0; i<m_pcPicVSP->getPicSym()->getNumberOfCUsInFrame(); i++ )
+  {
+    m_pcPicVSP->getPicSym()->getCU(i)->getCUMvField(RefPicList(0))->clearMvField();
+    m_pcPicVSP->getPicSym()->getCU(i)->getCUMvField(RefPicList(1))->clearMvField();
+  }
+#if DEPTH_MAP_GENERATION
+#if !QC_MULTI_DIS_CAN
+  // add extra pic buffers
+  Bool  bNeedPrdDepthMapBuf = ( m_uiPredDepthMapGeneration > 0 );
+  if( bNeedPrdDepthMapBuf && !m_pcPicVSP->getPredDepthMap() )
+  {
+    m_pcPicVSP->addPrdDepthMapBuffer( PDM_SUB_SAMP_EXP_X(m_uiPredDepthMapGeneration), PDM_SUB_SAMP_EXP_Y(m_uiPredDepthMapGeneration) );
+    m_cDepthMapGenerator.clearDepthMap( m_pcPicVSP );
+  }
+#endif
+#endif
+  m_pcPicAvail->setCurrSliceIdx( 0 );
+  m_pcPicAvail->getCurrSlice()->setSPS( this->getSPS() );
+  m_pcPicAvail->getCurrSlice()->setPPS( this->getPPS() );
+  m_pcPicAvail->getCurrSlice()->setPPSId( this->getPPS()->getPPSId() );
+  //initialize the motion vector field with zeros - How about the RefIdx ????
+  //IS THIS REALLY NECESSARY ????
+  for ( int i=0; i<m_pcPicAvail->getPicSym()->getNumberOfCUsInFrame(); i++ )
+  {
+    m_pcPicAvail->getPicSym()->getCU(i)->getCUMvField(RefPicList(0))->clearMvField();
+    m_pcPicAvail->getPicSym()->getCU(i)->getCUMvField(RefPicList(1))->clearMvField();
+  }
+#if DEPTH_MAP_GENERATION
+#if !QC_MULTI_DIS_CAN
+  // add extra pic buffers
+  bNeedPrdDepthMapBuf = ( m_uiPredDepthMapGeneration > 0 );
+  if( bNeedPrdDepthMapBuf && !m_pcPicVSP->getPredDepthMap() )
+  {
+    m_pcPicAvail->addPrdDepthMapBuffer( PDM_SUB_SAMP_EXP_X(m_uiPredDepthMapGeneration), PDM_SUB_SAMP_EXP_Y(m_uiPredDepthMapGeneration) );
+    m_cDepthMapGenerator.clearDepthMap( m_pcPicAvail );
+  }
+#endif
+#endif
+#endif
 }
 
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncTop.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncTop.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncTop.h	(revision 166)
@@ -145,4 +145,13 @@
   TEncAnalyze             m_cAnalyzeB;
 
+#if VSP_N
+  TComPic*                m_pcPicVSP;                     ///< view synthesis prediction buffer for current POC to be coded
+  TComPic*                m_pcPicAvail;
+#endif
+
+#if VSP_SLICE_HEADER
+  Bool                    m_bUseVSP;
+#endif
+
 protected:
   Void  xGetNewPicBuffer  ( TComPic*& rpcPic );           ///< get picture buffer which will be processed
@@ -237,4 +246,13 @@
   TComResidualGenerator*  getResidualGenerator  () { return  &m_cResidualGenerator;   }
 #endif
+#if VSP_N
+  TComPic*                getVSPBuf             () { return m_pcPicVSP; }
+  TComPic*                getVSPAvailBuf        () { return m_pcPicAvail; }
+#endif
+
+#if VSP_SLICE_HEADER
+  Void                    setUseVSP   ( Bool val ) { m_bUseVSP = val; }
+  Bool                    getUseVSP             () { return m_bUseVSP; }
+#endif
 
   // -------------------------------------------------------------------------------------------------------------------
